package com.fr.plugin.decision.api;

import com.fr.decision.fun.impl.AbstractControllerRegisterProvider;
import com.fr.plugin.context.PluginContext;
import com.fr.plugin.context.PluginContexts;
import com.fr.plugin.decision.api.controller.bi.*;
import com.fr.plugin.decision.api.controller.platform.AuthorityController;
import com.fr.plugin.decision.api.controller.platform.EntryController;
import com.fr.plugin.decision.api.controller.platform.PlatformController;
import com.fr.plugin.decision.api.controller.platform.UserController;
import com.fr.plugin.decision.api.utils.ModuleUtils;
import com.fr.plugin.transform.ExecuteFunctionRecord;
import com.fr.plugin.transform.FunctionRecorder;
import com.fr.stable.ArrayUtils;
import com.fr.stable.fun.Authorize;

/**
 * @Author JianYe.Wang
 * @Data 2021/7/12 16:40
 * @Description TODO
 * @Version 10.0
 **/
@Authorize(callSignKey = "com.fr.plugin.decision.bi.api")
@FunctionRecorder
public class APIControllerBridge extends AbstractControllerRegisterProvider {

    @Override
    @ExecuteFunctionRecord
    public Class<?>[] getControllers() {
        if (!PluginContexts.currentContext().isAvailable()) return new Class[0];
        return ModuleUtils.productContainBIModule() ? getBIModuleResources() : getFRModuleResources();
    }

    private Class<?>[] getFRModuleResources() {
        Class[] platformControllers = new Class[]{
                UserController.class,
                EntryController.class,
                PlatformController.class
        };
        return platformControllers;
    }

    private Class<?>[] getBIModuleResources() {
        Class[] biControllers = new Class[]{
                DirectConfResource.class,
                DashboardResource.class,
                AuthorityController.class,
                HandoverController.class,
                SpiderApiController.class,
                GroupResources.class
        };
        return ArrayUtils.addAll(getFRModuleResources(), biControllers);
    }
}
