package com.fr.plugin.decision.api.bean;

import com.finebi.foundation.api.reponse.FineRespond;
import com.fr.third.fasterxml.jackson.annotation.JsonInclude;

import java.util.HashMap;
import java.util.Map;

/**
 * @Author JianYe.Wang
 * @Data 2021/11/24 18:46
 * @Description TODO
 * @Version 10.0
 **/
@JsonInclude(JsonInclude.Include.NON_DEFAULT)
public class FineRespondNotNull extends FineRespond {

    private final static Map<String, String> ERROR_CODE_MAP = new HashMap<>();

    public FineRespondNotNull() {
    }

    public FineRespondNotNull(FineRespond fineRespond) {
        setErrorCode(fineRespond.getErrorCode());
        setErrorMsg(ERROR_CODE_MAP.containsKey(fineRespond.getErrorCode()) ? ERROR_CODE_MAP.get(fineRespond.getErrorCode()) : fineRespond.getErrorMsg());
    }

    // https://kms.fineres.com/pages/viewpage.action?pageId=129713504
    static {
        ERROR_CODE_MAP.put("61500001", "公式语法错误");
        ERROR_CODE_MAP.put("61500002", "非聚合公式存在明细过滤");
        ERROR_CODE_MAP.put("61500003", "聚合公式和非聚合公式进行运算");
        ERROR_CODE_MAP.put("61500004", "聚合函数中使用聚合参数");
        ERROR_CODE_MAP.put("61500005", "聚合函数存在多个指标");
        ERROR_CODE_MAP.put("61500006", "快速计算函数只有第一个可以是公式");
        ERROR_CODE_MAP.put("61500007", "快速计算函数内参数没有聚合函数");
        ERROR_CODE_MAP.put("61310001", "连接失败");
        ERROR_CODE_MAP.put("61310002", "字段缺失");
        ERROR_CODE_MAP.put("61310003", "字段正在被使用");
        ERROR_CODE_MAP.put("61310004", "字段重复");
        ERROR_CODE_MAP.put("61310005", "字段没有权限");
        ERROR_CODE_MAP.put("61310006", "分组缺失");
        ERROR_CODE_MAP.put("61310007", "分组正在被使用");
        ERROR_CODE_MAP.put("61310008", "分组重复");
        ERROR_CODE_MAP.put("61310009", "分组没有权限");
        ERROR_CODE_MAP.put("61310010", "业务包缺失");
        ERROR_CODE_MAP.put("61310011", "业务包正在被使用");
        ERROR_CODE_MAP.put("61310012", "业务包重复");
        ERROR_CODE_MAP.put("61310013", "没有业务包权限");
        ERROR_CODE_MAP.put("61310014", "表缺失");
        ERROR_CODE_MAP.put("61310015", "表正在使用");
        ERROR_CODE_MAP.put("61310016", "表重复");
        ERROR_CODE_MAP.put("61310017", "表没有权限");
        ERROR_CODE_MAP.put("61310018", "关联缺失");
        ERROR_CODE_MAP.put("61310019", "关联正在使用");
        ERROR_CODE_MAP.put("61310020", "关联重复");
        ERROR_CODE_MAP.put("61310021", "关联没有权限");
        ERROR_CODE_MAP.put("61310022", "不支持表类型");
        ERROR_CODE_MAP.put("61310023", "配置层面服务不支持");
        ERROR_CODE_MAP.put("61310024", "参数异常");
        ERROR_CODE_MAP.put("61310025", "名字重复");
        ERROR_CODE_MAP.put("61310026", "不合法路径");
        ERROR_CODE_MAP.put("61310027", "路径缺失");
        ERROR_CODE_MAP.put("61310028", "路径操作没有权限");
        ERROR_CODE_MAP.put("61310029", "对表进行的操作无效");
        ERROR_CODE_MAP.put("61310030", "路径不可达");
        ERROR_CODE_MAP.put("61310031", "分析操作不安全");
        ERROR_CODE_MAP.put("61310032", "模版重复");
        ERROR_CODE_MAP.put("61310033", "模版不存在");
        ERROR_CODE_MAP.put("61310034", "模版文件夹不存在");
        ERROR_CODE_MAP.put("61310050", "模版命名为空");
        ERROR_CODE_MAP.put("61310052", "分享被关闭");
        ERROR_CODE_MAP.put("61310036", "组件类型不支持");
        ERROR_CODE_MAP.put("61310037", "引擎服务异常");
        ERROR_CODE_MAP.put("61310044", "循环依赖报错");
        ERROR_CODE_MAP.put("61310045", "模版正在编辑");
        ERROR_CODE_MAP.put("61310046", "模版已挂出");
        ERROR_CODE_MAP.put("61310048", "未定义的异常信息");
        ERROR_CODE_MAP.put("61310053", "模版session找不到");
        ERROR_CODE_MAP.put("62400004", "组件没有数据");
        ERROR_CODE_MAP.put("62400003", "没有权限获取组件的数据");
        ERROR_CODE_MAP.put("61310049", "模版session id已经关闭异常");
        /*ERROR_CODE_MAP.put("61310032", "保存异常");
        ERROR_CODE_MAP.put("61310033", "更新异常");
        ERROR_CODE_MAP.put("61310034", "删除异常");
        ERROR_CODE_MAP.put("61310035", "查询异常");*/
        ERROR_CODE_MAP.put("61300302", "字段名或表名长度超出key值长度限制，无法保存到配置");
        ERROR_CODE_MAP.put("61310039", "排序获取名字错误");
        ERROR_CODE_MAP.put("61310040", "查询错误");
        ERROR_CODE_MAP.put("61310041", "字段类型错误");
        ERROR_CODE_MAP.put("61310042", "sheet页错误");
        ERROR_CODE_MAP.put("61310043", "sheet表头错误");
        ERROR_CODE_MAP.put("61310047", "sql错误");
        ERROR_CODE_MAP.put("62400006", "超出最大限制");
    }

}
