package com.fr.plugin.decision.api.bean.consanguinity.table;

import com.finebi.burger.api.bean.configuration.consanguinity.TableConsanguinityInfo;
import com.finebi.common.api.vo.table.AbstractFineTable;
import com.finebi.common.api.vo.table.FineDBBusinessTable;
import com.finebi.common.api.vo.table.FineSQLBusinessTable;
import org.apache.htrace.shaded.fasterxml.jackson.annotation.JsonInclude;

/**
 * @Author JianYe.Wang
 * @Data 2022/2/10 11:12
 * @Description TODO
 * @Version 10.0
 **/
public class XTableConsanguinityInfo extends TableConsanguinityInfo {

    private int type;
    @JsonInclude(JsonInclude.Include.NON_NULL)
    private String sql;
    @JsonInclude(JsonInclude.Include.NON_NULL)
    private String tableName;

    public XTableConsanguinityInfo() {
    }

    public XTableConsanguinityInfo(TableConsanguinityInfo info, AbstractFineTable table) {
        setStatus(info.getStatus());
        setSonTables(info.getSonTables());
        setFatherTables(info.getFatherTables());
        setUsage(info.getUsage());
        setPosition(info.getPosition());
        setName(info.getName());
        setTransferName(info.getTransferName());
        setComment(info.getComment());
        setCreateBy(info.getCreateBy());
        setCreateTime(info.getCreateTime());
        this.type = table.getType();
        switch (table.getType()) {
            case 1: //db数据集
                this.tableName = ((FineDBBusinessTable) table).getTableName();
                break;
            case 2: //SQL数据集
                this.sql = ((FineSQLBusinessTable) table).getSql();
                break;
        }
    }

    public int getType() {
        return type;
    }

    public void setType(int type) {
        this.type = type;
    }

    public String getSql() {
        return sql;
    }

    public void setSql(String sql) {
        this.sql = sql;
    }

    public String getTableName() {
        return tableName;
    }

    public void setTableName(String tableName) {
        this.tableName = tableName;
    }
}
