package com.fr.plugin.decision.api.bean.dashboard;

import com.finebi.burger.impl.service.helper.VOToBeanConverter;
import com.finebi.dashboard.api.response.report.dashboard.ReportIndexBean;
import com.finebi.dashboard.impl.service.helper.ReportIndexConverter;
import com.fr.decision.finebi.data.report.ReportIndex;

import java.util.Objects;

/**
 * @Author JianYe.Wang
 * @Data 2021/10/25 16:44
 * @Description TODO
 * @Version 10.0
 **/
public class ReportIndexExpandBean extends ReportIndexBean {

    // 是否EXCEL插件创建
    private boolean isExcel;
    // 创建用户名称
    private String createByName;

    public ReportIndexExpandBean() {
    }

    public ReportIndexExpandBean(ReportIndexBean reportIndex) {
        setCreateBy(reportIndex.getCreateBy());
        setFolder(reportIndex.isFolder());
        setHangout(reportIndex.getHangout());
        setId(reportIndex.getId());
        setPid(reportIndex.getPid());
        setInitTime(reportIndex.getInitTime());
        setLastUpdateTime(reportIndex.getLastUpdateTime());
        setName(reportIndex.getName());
        setMountedDirIds(reportIndex.getMountedDirIds());
        setApplyTime(reportIndex.getApplyTime());
        if (Objects.nonNull(reportIndex.getPublicLink())) {
            setPublicLink(reportIndex.getPublicLink());
        }

        setWatermark(reportIndex.isWatermark());
        setShared(reportIndex.isShared());
    }

    public ReportIndexExpandBean(ReportIndex reportIndex) {
        setCreateBy(reportIndex.getCreateBy());
        setFolder(reportIndex.isFolder());
        setHangout(VOToBeanConverter.convertHangoutType(reportIndex.getHangout()));
        setId(reportIndex.getId());
        setPid(reportIndex.getpId());
        setInitTime(reportIndex.getInitTime());
        setLastUpdateTime(reportIndex.getLastUpdateTime());
        setName(reportIndex.getName());
        setMountedDirIds(reportIndex.getMountedDirIds());
        setApplyTime(reportIndex.getApplyTime());
        if (Objects.nonNull(reportIndex.getPublicLink())) {
            setPublicLink(ReportIndexConverter.convertPublicLink(reportIndex.getPublicLink()));
        }

        setWatermark(reportIndex.isWatermark());
        setShared(reportIndex.isShared());
    }

    public boolean isExcel() {
        return isExcel;
    }

    public void setExcel(boolean excel) {
        isExcel = excel;
    }

    public String getCreateByName() {
        return createByName;
    }

    public void setCreateByName(String createByName) {
        this.createByName = createByName;
    }

}
