package com.fr.plugin.decision.api.bean.pack;

import com.finebi.burger.api.bean.configuration.pack.SimplePackageBean;
import com.finebi.burger.api.bean.configuration.search.PackageTableSearchResultBean;
import com.finebi.burger.api.bean.configuration.table.BusinessTableBean;
import com.fr.decision.webservice.bean.BaseBean;

import java.util.LinkedHashMap;
import java.util.List;

/**
 * 搜索业务包和数据集的结果
 * @Author JianYe.Wang
 * @Data 2021/9/3 15:55
 * @Description {@link com.finebi.burger.api.bean.configuration.search.PackageTableSearchResultBean}
 * @Version 10.0
 **/
public class PackageTableSearchResult extends BaseBean {

    private List<SimplePackageBean> packs;
    private List<BusinessTableBean> tables;
    private LinkedHashMap<String, String> packPathMap;
    private LinkedHashMap<String, String> tablePathMap;
    private LinkedHashMap<String, String> packIdPathMap = new LinkedHashMap<>();
    private LinkedHashMap<String, String> tableIdPathMap = new LinkedHashMap<>();

    public PackageTableSearchResult() {
    }

    public PackageTableSearchResult(List<SimplePackageBean> packs, List<BusinessTableBean> tables, LinkedHashMap<String, String> packPathMap, LinkedHashMap<String, String> tablePathMap) {
        this.packs = packs;
        this.tables = tables;
        this.packPathMap = packPathMap;
        this.tablePathMap = tablePathMap;
    }

    public PackageTableSearchResult(List<SimplePackageBean> packs, List<BusinessTableBean> tables, LinkedHashMap<String, String> packPathMap, LinkedHashMap<String, String> tablePathMap, LinkedHashMap<String, String> packIdPathMap, LinkedHashMap<String, String> tableIdPathMap) {
        this.packs = packs;
        this.tables = tables;
        this.packPathMap = packPathMap;
        this.tablePathMap = tablePathMap;
        this.packIdPathMap = packIdPathMap;
        this.tableIdPathMap = tableIdPathMap;
    }

    public PackageTableSearchResult(PackageTableSearchResultBean resultBean) {
        this.tablePathMap = (LinkedHashMap<String, String>) resultBean.getTableNameGroupPathMap();
        this.packPathMap = resultBean.getPackIdGroupPathMap();
        this.packs = resultBean.getFindPackages();
        this.packs.addAll(resultBean.getMatchPackages());
        this.tables = resultBean.getFindTableResult().getTables();
        this.tables.addAll(resultBean.getMatchTableResult().getTables());
    }

    public List<SimplePackageBean> getPacks() {
        return packs;
    }

    public void setPacks(List<SimplePackageBean> packs) {
        this.packs = packs;
    }

    public List<BusinessTableBean> getTables() {
        return tables;
    }

    public void setTables(List<BusinessTableBean> tables) {
        this.tables = tables;
    }

    public LinkedHashMap<String, String> getTablePathMap() {
        return tablePathMap;
    }

    public void setTablePathMap(LinkedHashMap<String, String> tablePathMap) {
        this.tablePathMap = tablePathMap;
    }

    public LinkedHashMap<String, String> getPackPathMap() {
        return packPathMap;
    }

    public void setPackPathMap(LinkedHashMap<String, String> packPathMap) {
        this.packPathMap = packPathMap;
    }

    public LinkedHashMap<String, String> getTableIdPathMap() {
        return tableIdPathMap;
    }

    public void setTableIdPathMap(LinkedHashMap<String, String> tableIdPathMap) {
        this.tableIdPathMap = tableIdPathMap;
    }

    public LinkedHashMap<String, String> getPackIdPathMap() {
        return packIdPathMap;
    }

    public void setPackIdPathMap(LinkedHashMap<String, String> packIdPathMap) {
        this.packIdPathMap = packIdPathMap;
    }
}
