package com.fr.plugin.decision.api.controller.bi;

import com.finebi.activate.foundation.StableManager;
import com.finebi.common.authority.api.FineUserUtils;
import com.finebi.common.exception.platform.FineAuthorityExecuteException;
import com.finebi.dashboard.api.bean.report.MoveReportDirBean;
import com.finebi.dashboard.api.bean.report.ReportDirBean;
import com.finebi.dashboard.api.bean.report.ReportSearchBean;
import com.finebi.dashboard.api.bean.report.consanguinity.ReportConsanguinityBean;
import com.finebi.dashboard.api.cell.DashboardCellCreator;
import com.finebi.dashboard.api.response.report.dashboard.ReportErrorInfoBean;
import com.finebi.dashboard.api.response.report.dashboard.ReportIndexBean;
import com.finebi.dashboard.impl.helper.FineReportUtils;
import com.finebi.dashboard.impl.service.helper.CataLogHelper;
import com.finebi.dashboard.impl.service.helper.consanguinity.ReportConsanguinityHelper;
import com.finebi.direct.burger.api.service.FineUserInfoService;
import com.finebi.foundation.api.reponse.FineRespond;
import com.finebi.utils.CollectionUtils;
import com.finebi.web.action.v5.BaseAction;
import com.finebi.widget.api.cell.user.AuthorityUserCreator;
import com.fr.decision.authority.data.User;
import com.fr.decision.finebi.bean.BiReportBean;
import com.fr.decision.finebi.data.report.ReportIndex;
import com.fr.decision.webservice.Response;
import com.fr.decision.webservice.annotation.FinePathVariable;
import com.fr.decision.webservice.bean.entry.EntryMoveBean;
import com.fr.decision.webservice.v10.dashboard.BiDashBoardCondition;
import com.fr.decision.webservice.v10.dashboard.BiDashBoardService;
import com.fr.decision.webservice.v10.entry.BiReportService;
import com.fr.decision.webservice.v10.entry.EntryService;
import com.fr.decision.webservice.v10.user.UserService;
import com.fr.log.FineLoggerFactory;
import com.fr.plugin.decision.api.bean.*;
import com.fr.plugin.decision.api.bean.consanguinity.DetailReportConsanguinityBean;
import com.fr.plugin.decision.api.bean.dashboard.ReportIndexExpandBean;
import com.fr.plugin.decision.api.bean.dashboard.ShareDashboard;
import com.fr.plugin.decision.api.direct.service.XFineDashBoardServiceImpl;
import com.fr.plugin.decision.api.excel.ExcelReportSelector;
import com.fr.plugin.decision.api.service.APIService;
import com.fr.plugin.decision.api.service.DashboardService;
import com.fr.plugin.decision.api.service.DashboardTableFinder;
import com.fr.plugin.decision.api.service.consanguinity.XReportConsanguinityHelper;
import com.fr.stable.StringUtils;
import com.fr.third.springframework.stereotype.Controller;
import com.fr.third.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.util.*;
import java.util.stream.Collectors;

/**
 * @Author JianYe.Wang
 * @Data 2021/8/3 17:24
 * @Description TODO
 * @Version 10.0
 **/
@Controller
@RequestMapping(value = "/api/v5/plugin/dashboard")
public class DashboardResource extends BaseAction {

    /**
     * 新建仪表板、文件夹
     * @param req
     * @param reportDirBean
     * @return
     * @throws Exception
     */
    @RequestMapping(
            value = {"reports"},
            method = {RequestMethod.POST}
    )
    @ResponseBody
    public Response creatDashboardAndFolder(HttpServletRequest req,
                                               @RequestBody ReportDirBean reportDirBean) throws Exception {
        String userId = FineUserUtils.getUserIdFromReq(req);
        //ReportIndexBean reportIndex;
        if (reportDirBean.isFolder()) {
            return Response.ok(XFineDashBoardServiceImpl.getInstance().createNewReportFolder(reportDirBean, userId));
            /*String newName = reportDirBean.getName();
            reportIndex = getDashboardService().createNewReportFolder(reportDirBean, userId);
            reportDirBean.setReportId(reportIndex.getId());
            reportDirBean.setNewName(newName);
            boolean result = false;
            try {
                result = getDashboardService().renameReportDirBean(reportDirBean, userId);
            } catch (Exception e) {
                getDashboardService().removeDirBean(reportDirBean, userId);
                return Response.error("creatFolder", e.getMessage());
            }
            reportIndex.setName(newName);
            return result ? Response.ok(reportIndex) : Response.error("creatFolder", "folder name is illegal or duplicate!");*/
        } else {
            /*reportIndex = getDashboardService().createNewReport(reportDirBean, userId);
            return Response.ok(reportIndex);*/
            return Response.ok(XFineDashBoardServiceImpl.getInstance().createNewReport(reportDirBean, userId));
        }
    }

    /**
     * 重命名仪表板和文件夹
     * @param req
     * @param reportDirBean
     * @return
     * @throws Exception
     */
    @RequestMapping(
            value = {"reports/rename"},
            method = {RequestMethod.PUT}
    )
    @ResponseBody
    public Response renameDashBoardAndFolder(HttpServletRequest req,
                                    @RequestBody ReportDirBean reportDirBean) throws Exception {
        String userId = FineUserUtils.getUserIdFromReq(req);
        boolean success = getDashboardService().renameReportDirBean(reportDirBean, userId);
        return success ? Response.success() : Response.error("renameDashBoardAndFolder", "name is illegal or duplicate!");
    }

    // todo: 模板正在编辑时无法删除
    @RequestMapping(
            value = {"reports"},
            method = {RequestMethod.DELETE}
    )
    @ResponseBody
    public Response deleteDashBoard(HttpServletRequest req,
                                    @RequestBody ReportDirBean reportDirBean) throws Exception {
        if (!getDashboardService().checkReportIndex(reportDirBean)) {
            return Response.error(StringUtils.EMPTY, "parameter is invalid!");
        }
        String userId = FineUserUtils.getUserIdFromReq(req);
        if (!getReportAuthService().isCreateByMe(reportDirBean.getReportId(), userId)) {
            return Response.error(StringUtils.EMPTY, "Current user not dashboard creator!");
        }
        List<ReportErrorInfoBean> errors = getDashboardService().removeDirBean(Arrays.asList(reportDirBean), userId).getFailed();
        if (errors.isEmpty()) {
            return Response.success();
        }
        return  Response.error(StringUtils.EMPTY, errors.get(0).getMessage());
    }

    @RequestMapping(
            value = {"reports/saveas"},
            method = {RequestMethod.POST}
    )
    @ResponseBody
    public Response saveDashboardAs(HttpServletRequest req,
                                    @RequestBody MoveReportDirBean reportDirBean) throws Exception {
        String userId = FineUserUtils.getUserIdFromReq(req);
        ReportIndexBean data = getDashboardService().saveAs(reportDirBean, userId);
        return Response.ok(data);
    }

    /**
     * 挂载仪表板
     * @param req
     * @param reportIndex
     * @return
     * @throws Exception
     */
    @RequestMapping(
            value = {"reports/hangout"},
            method = {RequestMethod.POST}
    )
    @ResponseBody
    public Response hangoutDashboard(HttpServletRequest req,
                                     @RequestBody ReportIndexBean reportIndex) throws Exception {
        User user = FineUserUtils.getUserByRequest(req);
        if (getReportAuthService().isCreateByMe(reportIndex.getId(), user.getId())) {
            boolean data = FineReportUtils.updateHangOut(reportIndex.getId(), reportIndex, user, getReportIndexService());
            return data ? Response.success() : Response.error("hangoutDashboard", "Hangout dashboard failed, please check the log file!");
        } else {
            return Response.error("hangoutDashboard", "request parameter is invalid!");
        }
    }

    /**
     * 移动
     * @param req
     * @param reportDirBean
     * @return
     * @throws Exception
     */
    @RequestMapping(
            value = {"reports/move"},
            method = {RequestMethod.POST}
    )
    @ResponseBody
    public Response moveDashboard(HttpServletRequest req,
                                  @RequestBody MoveReportDirBean reportDirBean) throws Exception {
        String userId = FineUserUtils.getUserIdFromReq(req);
        List<String> reportIds = new ArrayList<>();
        if (!reportDirBean.getFrom().isEmpty()) {
            for (ReportDirBean fromBean : reportDirBean.getFrom()) {
                reportIds.add(fromBean.getReportId());
            }
        }
        if (reportDirBean.getTo() != null) {
            String to = reportDirBean.getTo().getReportId();
            if (com.finebi.utils.StringUtils.isNotEmpty(to)) {
                reportIds.add(to);
            }
        }
        Optional<ReportIndex> to = getReportIndexService().getReportIndexById(reportDirBean.getTo().getReportId());
        if (!(to.isPresent() && to.get().isFolder())) {
            return Response.error(StringUtils.EMPTY, "The move destination does not exist or is not a folder!");
        }

        boolean data = false;
        if (getReportAuthService().isCreateByMe(reportIds, userId)) {
            data = getDashboardService().moveReports(reportDirBean.getFrom(), reportDirBean.getTo(), userId);
        }
        return data ? Response.success() : Response.error("moveDashboard", "Move dashboard failed, please check the log file!");
    }

    /**
     * 获取仪表板和文件夹列表
     * @param req
     * @param onlyFolder 是否仅文件夹
     * @param pId 基于pId进行过滤
     * @return
     * @throws Exception
     */
    @RequestMapping(
            value = {"reports"},
            method = {RequestMethod.GET}
    )
    @ResponseBody
    public Response getDashBoardList(HttpServletRequest req,
                                     @RequestParam(required = false, value = "onlyFolder") boolean onlyFolder,
                                     @RequestParam(required = false, value = "pId") String pId,
                                     @RequestParam(required = false, value = "st") String st,
                                     @RequestParam(required = false, value = "et") String et) throws Exception {
        User user = FineUserUtils.getUserByRequest(req);
        return Response.ok(DashboardService.getInstance().extendReportIndex(
                DashboardService.getInstance().getReportIndex(user.getId(), onlyFolder, pId, st, et),
                new HashMap<String, String>(1){{ put(user.getId(), user.getUserName()); }}));
    }

    /**
     * 搜索仪表板和文件夹
     *  仪表板需要补全完整的树结构
     * @param req
     * @param reportIndexKeyWord
     * @return
     * @throws Exception
     */
    @RequestMapping(
            value = {"reports/search"},
            method = {RequestMethod.POST}
    )
    @ResponseBody
    public Response searchDashBoard(HttpServletRequest req,
                                    @RequestBody ReportSearchBean reportIndexKeyWord) throws Exception {
        User user = FineUserUtils.getUserByRequest(req);
        HashMap<String, String> userIdNameMap = new HashMap<String, String>(1){{ put(user.getId(), user.getUserName()); }};
        Set<String> excelReportIdSet = ExcelReportSelector.getInstance().getReportIds();
        List<ReportIndexBean> searchResult = getDashboardService().searchKeyWord(reportIndexKeyWord, user.getId());
        List<ReportIndexExpandBean> result = searchResult.stream()
                .map(reportIndexBean->DashboardService.getInstance().extendReportIndex(new ReportIndexExpandBean(reportIndexBean), excelReportIdSet, userIdNameMap))
                .collect(Collectors.toList());
        // 添加模板的父节点，填充成完整的树
        List<ReportIndex> parents = new ArrayList<>();
        for (ReportIndexBean reportIndexBean : searchResult) {
            parents.addAll(APIService.getInstance().getReportFullPathIndex(reportIndexBean.getId(), reportIndexBean.getCreateBy()));
        }
        result.addAll(parents.stream()
                .distinct()
                .map(reportIndex -> DashboardService.getInstance().extendReportIndex(new ReportIndexExpandBean(reportIndex), excelReportIdSet, userIdNameMap))
                .peek(reportIndexBean -> reportIndexBean.setParents(DashboardCellCreator.reportIndex().getReportParents(reportIndexBean.getId())))
                .collect(Collectors.toList()));
        return Response.ok(result);
    }

    @RequestMapping(value = "/info", method = RequestMethod.GET)
    @ResponseBody
    public Response getTemplateInfoById(HttpServletRequest request,
                                        @RequestParam(value = "templateId", required = false) String templateId,
                                        @RequestParam(value = "folderId", required = false) String folderId) throws Exception {
        User user = FineUserUtils.getUserByRequest(request);
        if (StringUtils.isNotBlank(templateId)) {
            Optional<ReportIndex> reportIndex = getReportIndexService().getReportIndexById(templateId);
            if (reportIndex.isPresent()) {
                return Response.ok(DashboardService.getInstance().extendReportIndex(new ReportIndexExpandBean(reportIndex.get())));
            }
        }
        if (StringUtils.isNotBlank(folderId)) {
            return Response.ok(DashboardService.getInstance().extendReportIndex(
                    getReportIndexService().getChildReportIndexsByFolderId(folderId),
                    new HashMap<String, String>(1){{ put(user.getId(), user.getUserName()); }})
            );
        }
        return Response.error("getTemplateInfoById", "request parameter is invalid!");
    }

    /**
     * 查询模板的血缘关系信息
     *
     * @param request
     * @param templateId
     * @return
     */
    @RequestMapping(value = "/report/consanguinity", method = RequestMethod.GET)
    @ResponseBody
    public Response getTemplateConsanguinity(HttpServletRequest request,
                                             @RequestParam(value = "templateId") String templateId) throws Exception {
        String userId = FineUserUtils.getUserIdFromReq(request);
        ReportConsanguinityBean original = new XReportConsanguinityHelper(AuthorityUserCreator.create(userId))
                .getReportConsanguinityByReportId(templateId);
        DetailReportConsanguinityBean detail = new DetailReportConsanguinityBean(original);
        return Response.ok(detail);
    }

    @ResponseBody
    @RequestMapping(
            value = {"/reports/authority/search"},
            method = {RequestMethod.POST}
    )
    public Response searchDashboards(HttpServletRequest req,
                                     @RequestBody BiDashBoardCondition condition) throws Exception {
        return Response.ok(BiDashBoardService.getInstance().searchDashboards(UserService.getInstance().getCurrentUserId(req), condition).get("reportIndexList"));
    }

    @ResponseBody
    @RequestMapping(
            value = {"/reports/entry"},
            method = {RequestMethod.POST}
    )
    public Response addDashboard2PlatformEntry(HttpServletRequest req,
                                               @RequestBody BiReportBean biReportBean) throws Exception {
        long start = System.currentTimeMillis();
        if (biReportBean.getTemplateId() == null)
            return Response.error("Add dashboard to platform", "dashboard template id is null!");
        String userId = FineUserUtils.getUserIdFromReq(req);
        biReportBean.setPath(APIService.getInstance().getReportFullPath4PlatformEntry(biReportBean.getTemplateId()));
        List<BiReportBean> biReportBeanList = BiReportService.getInstance().addBiReport(userId, biReportBean.getpId(), new BiReportBean[]{biReportBean});
        long addEnd = System.currentTimeMillis();
        APIService.getInstance().refreshCache();
        long refreshEnd = System.currentTimeMillis();
        FineLoggerFactory.getLogger().info("Add dashboard id:{} spend:{} {}", biReportBean.getTemplateId(), addEnd - start, refreshEnd - start);
        return Response.ok(biReportBeanList.get(0));
    }

    @ResponseBody
    @RequestMapping(
            value = {"/reports/entry"},
            method = {RequestMethod.PUT}
    )
    public Response editDashboardEntry(@RequestBody DashboardEntryEditBean entryEditBean,
                                       HttpServletRequest request) {
        if (entryEditBean.getId() == null)
            return Response.error("Edit platform dashboard entry", "dashboard entry id is null!");
        try {
            String userId = FineUserUtils.getUserIdFromReq(request);
            APIService.getInstance().updateDashboardEntry(entryEditBean);
            BiReportService.getInstance().editBiReport(userId, entryEditBean.getId(), entryEditBean);
            if (entryEditBean.getpId() != null) {
                EntryMoveBean moveBean = new EntryMoveBean();
                moveBean.setTargetId(entryEditBean.getpId());
                moveBean.setMoveEntryIds(new String[]{entryEditBean.getId()});
                EntryService.getInstance().moveEntry(moveBean);
            }
            APIService.getInstance().refreshCache();
            return Response.success();
        } catch (Exception e) {
            FineLoggerFactory.getLogger().error(e.getMessage(), e);
            return Response.error("Edit entry dashboard info", e.getMessage());
        }
    }

    @ResponseBody
    @RequestMapping(
            value = {"/reports/check"},
            method = {RequestMethod.POST}
    )
    public Response checkDashboardDuplicateName(HttpServletRequest req,
                                                @RequestBody ReportDirBean[] reportDirBeans) throws Exception {
        String userId = FineUserUtils.getUserIdFromReq(req);
        CataLogHelper cataLogHelper = new CataLogHelper(userId);
        ArrayList result = new ArrayList(reportDirBeans.length);
        for (ReportDirBean reportDirBean : reportDirBeans) {
            String pid = cataLogHelper.getParentIdByReportDirBean(reportDirBean);
            List<ReportIndex> reportIndexList = DashboardCellCreator.reportIndex().findSimilarReportIndex(pid, reportDirBean.getName(), reportDirBean.isFolder());
            result.add(CollectionUtils.isEmpty(reportIndexList));
        }
        return Response.ok(result);
    }

    @ResponseBody
    @RequestMapping(
            value = {"/entry/{entryId}/info"},
            method = {RequestMethod.GET}
    )
    public Response getEntryDashboardInfo(@FinePathVariable("entryId") String entryId) throws Exception {
        List<BiReportBean> dashboardList = APIService.getInstance().getDashboardByEntryID(entryId);
        /*List<DashboardEntryInfo> infoList = new ArrayList<>();
        for (BiReportBean biReportBean : dashboardList) {
            infoList.add(getInfoByBiReportBean(biReportBean));
        }
        return Response.ok(infoList);*/
        return Response.ok(dashboardList.stream().map(this::getInfoByBiReportBean).collect(Collectors.toList()));
    }

    private Object getInfoByBiReportBean(BiReportBean entryBean) {
        try {
            Optional<ReportIndex> optional = getReportIndexService().getReportIndexById(entryBean.getTemplateId());
            if (!optional.isPresent()) {
                return Response.error("", "Dashboard " + entryBean.getTemplateId() + " not exist!");
            }
            ReportIndex reportIndex = optional.get();
            User user = UserService.getInstance().getUserByUserId(String.valueOf(reportIndex.getCreateBy()));
            String username = user == null ? String.valueOf(reportIndex.getCreateBy()) : user.getUserName();
            return new DashboardEntryInfo(
                    entryBean.getId(),
                    entryBean.getTemplateId(),
                    reportIndex.getInitTime(),
                    username
            );
        } catch (Exception  e) {
            return Response.error("", e.getMessage());
        }
    }

    /**
     * 处理下异常返回值统一格式只返回 errorCode errorMsg
     * @param ex
     * @return
     */
    @ExceptionHandler(Exception.class)
    @ResponseBody
    public FineRespondNotNull exceptionRespond(Exception ex) {
        return new FineRespondNotNull(getExceptionRespond(ex));
    }

    /**
     *
     * @param userTemplateBean
     * @return
     * @throws FineAuthorityExecuteException
     */
    @RequestMapping(value = "/reports/table/authority", method = RequestMethod.POST)
    @ResponseBody
    public Response checkUserHasTableAuth(@RequestBody UserTemplateBean userTemplateBean) throws Exception {
        DashboardTableFinder finder = new DashboardTableFinder(userTemplateBean.getReportId());
        finder.findAllTableWithNoAuth(getFineUserInfoService().getUserAuthority(APIService.getInstance().transferUser2Id(userTemplateBean.getUser())));
        return Response.ok(finder);
    }

    private static FineUserInfoService getFineUserInfoService() {
        return StableManager.getContext().getServiceBean(FineUserInfoService.class);
    }

    /**
     * 分享仪表板
     * @param request
     * @param dashboards
     * @return
     */
    @RequestMapping(method = RequestMethod.POST, value = "/share")
    @ResponseBody
    public Response shareDashboard(HttpServletRequest request,
                                   @RequestBody List<ShareDashboard> dashboards) throws Exception {
        String userId = UserService.getInstance().getCurrentUserId(request);
        dashboards.stream().peek(e -> {
            try {
                DashboardService.getInstance().shareDashboard(e, userId);
            } catch (Exception e1) {
                throw new RuntimeException(e1);
            }
        }).count();
        return Response.ok(dashboards);
    }




}
