package com.fr.plugin.decision.api.controller.bi;

import com.finebi.burger.api.bean.configuration.table.field.FineBusinessField;
import com.finebi.common.api.cell.SpiderCellCreator;
import com.finebi.common.api.cell.user.authority.UserAuthority;
import com.finebi.spider.web.action.v5.conf.SpiderConfAction;
import com.fr.decision.webservice.Response;
import com.fr.decision.webservice.annotation.FinePathVariable;
import com.fr.log.FineLoggerFactory;
import com.fr.third.springframework.stereotype.Controller;
import com.fr.third.springframework.web.bind.annotation.RequestMapping;
import com.fr.third.springframework.web.bind.annotation.RequestMethod;
import com.fr.third.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;
import java.util.Arrays;
import java.util.List;
import java.util.Map;

/**
 * @Author JianYe.Wang
 * @Data 2021/11/11 10:04
 * @Description TODO
 * @Version 10.0
 **/
@Controller
@RequestMapping("/api/v5/plugin/spider")
public class SpiderApiController extends SpiderConfAction {

    /**
     * 查询数据集列id {@link com.fr.decision.webservice.v10.pack.BiPackageService#getTableFields(String, String, boolean)}
     *
     * @param request
     * @param tableId
     * @return
     * @throws Exception
     */
    @ResponseBody
    @RequestMapping(
            value = {"/tables/{tableId}/columns"},
            method = {RequestMethod.GET}
    )
    public Response addAnalysisTables(HttpServletRequest request,
                                      @FinePathVariable("tableId") String tableId) throws Exception {
        try {
            UserAuthority authorityUser = getFineUserInfoService().getUserAuthority(request);
            Map<String, List<FineBusinessField>> fieldMap = SpiderCellCreator.getCellProvider().tableCell().getTableFields(Arrays.asList(tableId), authorityUser);
            return Response.ok(fieldMap.get(tableId));
        } catch (Exception e) {
            FineLoggerFactory.getLogger().error(e.getMessage(), e);
            return Response.error("Spider query table columns", e.getMessage());
        }
    }

}
