package com.fr.plugin.decision.api.utils;

import com.fr.decision.webservice.v10.register.utils.RegisterInfoUtil;
import com.fr.log.FineLoggerFactory;
import com.fr.stable.StringUtils;
import com.fr.stable.version.ProductVersion;

import java.util.List;

/**
 * @Author JianYe.Wang
 * @Data 2021/8/2 10:42
 * @Description TODO
 * @Version 10.0
 **/
public class ModuleUtils {

    /**
     * 是否包含 BI 模块
     *
     * @return
     */
    public static boolean productContainBIModule() {
        try {
            List<ProductVersion> versions = RegisterInfoUtil.generateRegisterVersionInfo();
            for (ProductVersion productVersion : versions) {
                if (StringUtils.equalsIgnoreCase(productVersion.getName(), "bi")) {
                    return true;
                }
            }
        } catch (Exception e) {
            FineLoggerFactory.getLogger().error(e.getMessage(), e);
        }
        return false;
    }

}
