;!(function () {
    if (new window.URL(window.location.href).searchParams.get('tableTab')) {
        //$('.dec-msg-wrapper').css('display', 'none');
        config();
    }

    function config() {
        BI.config('dec.body', function (obj) {
            obj.mounted = function () {
                $('.dec-frame-body').css('position', 'fixed').css('inset', '0 0 0 0');
            };
        });

        BI.config('bi.conf_content', function (obj) {
            obj.render = function () {
                var self = this;
                self.constant = BI.Providers.getProvider('bi.provider.conf.packlist').getItems();

                BI.createWidget(this.getDataListTabPanel());

                return {
                    type: BI.AbsoluteLayout.xtype,
                    items: [
                        {
                            el: {
                                type: BI.Tab.xtype,
                                cls: 'bi-card',
                                single: true,
                                showIndex: Number(
                                    new window.URL(window.location.href).searchParams.get('tableTab') || BICst.CONF.TABLE_DETAIL.PREVIEW
                                ),
                                cardCreator: function (index) {
                                    var constantType;
                                    if (index === BICst.CONF.TABLE_DETAIL.PREVIEW) {
                                        constantType = 'bi.constant.conf.pack.table.preview';
                                    } else {
                                        constantType = BI.Providers.getProvider('bi.provider.conf.pack.table.tab').getConstantType(index);
                                    }

                                    const tableType = self.model.selectedTable.hasOwnProperty("type") ? self.model.selectedTable.type : undefined;

                                    var constants = BI.Providers.getProvider('bi.provider.constants').getConstant(constantType);

                                    var config = BI.Services.getService('bi.service.conf').getConfigByType(constants, tableType);
                                    if (BI.isNotNull(config)) {
                                        return BI.extend({type: config.value}, config.options);
                                    }

                                    return {
                                        type: 'bi.conf.pack.table.preview',
                                    };
                                },
                            },
                            left: 0,
                            top: 0,
                            bottom: 0,
                            right: 0,
                        },
                    ],
                };
            };


        });
        BI.config('bi.conf.controller', function (obj) {
            obj.render = function () {
                var self = this;
                return {
                    type: BI.VTapeLayout.xtype,
                    items: [
                        {
                            height: 0,
                            el: {
                                type: 'bi.conf.controller.header',
                                ref: function (ref) {
                                    self.header = ref;
                                },
                                listeners: [
                                    {
                                        eventName: 'EVENT_ENGINE_CHANGE',
                                        action: function (v) {
                                            self.fireEvent('EVENT_ENGINE_CHANGE', v);
                                        },
                                    },
                                ],
                            },
                        },
                        {
                            el: {
                                type: 'bi.conf.controller.body',
                                ref: function (ref) {
                                    self.body = ref;
                                },
                            },
                        },
                    ],
                };
            };
        });

        // 隐藏展示行数设置
        BI.config('bi.components.preview_structure', function (obj) {
            obj.mounted = function () {
                this.rowCountLabel.setVisible(false);
                this.rowCountSettingIcon.setVisible(false);
            }
        })
    }
})();