package com.fr.plugin.test;

import com.finebi.dashboard.api.response.report.dashboard.ReportIndexBean;
import com.finebi.dashboard.api.response.report.dashboard.ReportPublicLinkBean;
import com.fr.decision.base.util.UUIDUtil;
import com.fr.plugin.decision.api.bean.dashboard.ReportIndexExpandBean;
import com.fr.third.fasterxml.jackson.databind.ObjectMapper;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.stream.Collectors;

/**
 * @Author JianYe.Wang
 * @Data 2022/1/19 16:09
 * @Description TODO
 * @Version 10.0
 **/
public class Change2SonBean {

    public static void main(String[] args) throws Exception {

        String userId1 = UUIDUtil.generate();
        String userId2 = UUIDUtil.generate();

        int count = 100000;
        ArrayList<ReportIndexBean> list = new ArrayList(count);
        for (int i=0; i<count; i++) {
            if (i % 2 == 0) {
                list.add(i, createBean(userId1));
            } else {
                list.add(i, createBean(userId2));
            }
        }


        ObjectMapper mapper = new ObjectMapper();
        long s = System.currentTimeMillis();

        HashMap<String, String> userIdNameMap = new HashMap<>();

        HashMap<String, String> userIdNameMapCount = new HashMap<>();
        userIdNameMapCount.put(userId1, "userId1");
        userIdNameMapCount.put(userId2, "userId2");
        ArrayList result = (ArrayList) list.stream().map(bean-> {
            //ReportIndexHasExcelAttr index = new ReportIndexHasExcelAttr();
            /*try {
                BeanUtils.copyProperties(index, bean);
                return index;
            } catch (Exception e) {
                throw new RuntimeException(e);
            }*/
            /*try {
                return mapper.readValue(mapper.writeValueAsString(bean), ReportIndexHasExcelAttr.class);
            } catch (Exception e) {
                throw new RuntimeException(e);
            }*/
            ReportIndexExpandBean index = new ReportIndexExpandBean();
            index.setName(bean.getName());
            index.setParents(bean.getParents());
            index.setId(bean.getId());
            index.setCreateBy(bean.getCreateBy());
            index.setFolder(bean.isFolder());
            index.setInitTime(bean.getInitTime());
            index.setApplyTime(bean.getApplyTime());
            index.setLastUpdateTime(bean.getLastUpdateTime());
            index.setHangout(bean.getHangout());
            index.setShared(bean.isShared());
            index.setWatermark(bean.isWatermark());
            index.setPublicLink(bean.getPublicLink());

            if(userIdNameMap.containsKey(bean.getCreateBy())) {
                index.setCreateByName(userIdNameMap.get(bean.getCreateBy()));
            } else {
                String username = userIdNameMapCount.get(bean.getCreateBy());
                index.setCreateByName(username);
                System.out.println(username);
                userIdNameMap.put(bean.getCreateBy(), username);
            }
            return index;
        }).collect(Collectors.toList());
        long e = System.currentTimeMillis();
        System.out.println(e-s);
        System.out.println(result.get(0) instanceof ReportIndexExpandBean);



    }

    public static ReportIndexBean createBean(String userId) {
        ReportIndexBean report = new ReportIndexBean();
        report.setName("测试报表");
        report.setParents(Arrays.asList("123", "zcx"));
        report.setId(UUIDUtil.generate());
        report.setCreateBy(userId);
        report.setFolder(false);
        report.setInitTime(System.currentTimeMillis());
        report.setApplyTime(System.currentTimeMillis());
        report.setLastUpdateTime(System.currentTimeMillis());
        report.setHangout("hangout");
        report.setShared(false);
        report.setWatermark(false);

        ReportPublicLinkBean link = new ReportPublicLinkBean();
        link.setLinkId(UUIDUtil.generate());
        link.setPassProtected(false);
        link.setPassword("123");
        link.setReportId(UUIDUtil.generate());
        link.setUserId(UUIDUtil.generate());
        link.setUri(UUIDUtil.generate());
        report.setPublicLink(link);

        return report;
    }
}
